<template>
  <div
    data-component-group="auth-form"
    data-component="user-profile"
  >
    <Form
      title="Register"
      second-title="User profile"
    >
      <v-flex xs12>
        <v-layout>
          <v-text-field
            v-model="firstName"
            :label="$t('components.forms.user_profile.first_name_placeholder')"
            required
            type="text"
            class="first-name-field"
            :autofocus="true"
            :error-messages="firstNameErrors"
            @blur="$v.firstName.$touch()"
          />

          <v-text-field
            v-model="lastName"
            :label="$t('components.forms.user_profile.last_name_placeholder')"
            required
            type="text"
            :error-messages="lastNameErrors"
            @blur="$v.lastName.$touch()"
          />
        </v-layout>
      </v-flex>

      <v-text-field
        v-model="title"
        :label="$t('components.forms.user_profile.title_placeholder')"
        required
        type="text"
        :error-messages="titleErrors"
        @blur="$v.title.$touch()"
      />

      <v-text-field
        v-model="email"
        :label="$t('components.forms.user_profile.email_placeholder')"
        required
        disabled
        type="text"
        :error-messages="emailErrors"
        @blur="$v.email.$touch()"
      />

      <v-text-field
        v-model="password"
        :label="$t('components.forms.login.password_placeholder')"
        :append-icon="isPasswordVisible ? 'visibility_off' : 'visibility'"
        required
        :type="isPasswordVisible ? 'text' : 'password'"
        :error-messages="passErrors"
        @blur="$v.password.$touch()"
        @click:append="isPasswordVisible = !isPasswordVisible"
      />

      <v-flex xs12>
        <v-layout>
          <v-select
            v-model="language"
            :items="locales"
            label="Language"
            item-text="label"
            item-value="code"
            :return-object="true"
            required
            class="language-dropdown"
            :error-messages="languageErrors"
          />

          <v-select
            v-model="timezone"
            :items="timezones"
            label="Timezone"
            item-text="label"
            item-value="id"
            :return-object="true"
            required
            class="timezone-dropdown"
            :error-messages="timezoneErrors"
          />
        </v-layout>
      </v-flex>

      <div class="form-actions">
        <v-btn
          flat
          class="trigger register"
          @click="submit"
        >
          {{ $t('components.forms.user_profile.submit') }}
          <v-icon>
            chevron_right
          </v-icon>
        </v-btn>
      </div>
    </Form>
  </div>
</template>

<script>
  import { validationMixin } from 'vuelidate';
  import { required, minLength, email } from 'vuelidate/lib/validators';
  import colors from 'vuetify/es5/util/colors';
  import Form from '../Form';
  import router from '../../../router';
  import { config, hasLowercase, hasUppercase, hasSpecialSymbol } from '../../../validators/password';
  import locales from '../../../locales/locales.json';

  const pass = { ...config };
  const timezones = [{
    id: 1,
    label: 'Europe/Sofia'
  }, {
    id: 2,
    label: 'Europe/Berlin'
  }, {
    id: 3,
    label: 'Europe/London'
  }, {
    id: 4,
    label: 'America/Sao Paulo'
  }, {
    id: 5,
    label: 'America/Mexico City'
  }];

  export default {
    components: {
      Form
    },
    mixins: [validationMixin],
    validations: {
      firstName: {
        required
      },
      lastName: {
        required
      },
      title: {
        required
      },
      email: {
        required,
        email
      },
      password: {
        required,
        minLength: minLength(pass.length),
        hasLowercase,
        hasUppercase,
        hasSpecialSymbol
      },
      language: {
        required
      },
      timezone: {
        required
      }
    },
    props: {
      userProfile: {
        type: Object,
        required: true
      },
      onSubmit: {
        type: Function,
        required: true
      }
    },
    data: () => ({
      firstName: '',
      lastName: '',
      title: '',
      email: '',
      password: '',
      language: 'en',
      timezone: 1,
      isSubmitted: false,
      isLoading: false,
      isPasswordVisible: false,
      locales: [...locales],
      timezones: [...timezones],
      colors
    }),
    computed: {
      firstNameErrors() {
        const errors = [];
        if (!this.$v.firstName.$dirty) {
          return errors;
        }
        if (!this.$v.firstName.required) {
          errors.push(router.app.$t('components.forms.user_profile.errors.first_name_required'));
        }
        return errors;
      },
      lastNameErrors() {
        const errors = [];
        if (!this.$v.lastName.$dirty) {
          return errors;
        }
        if (!this.$v.lastName.required) {
          errors.push(router.app.$t('components.forms.user_profile.errors.last_name_required'));
        }
        return errors;
      },
      titleErrors() {
        const errors = [];
        if (!this.$v.title.$dirty) {
          return errors;
        }
        if (!this.$v.title.required) {
          errors.push(router.app.$t('components.forms.user_profile.errors.title_required'));
        }
        return errors;
      },
      emailErrors() {
        const errors = [];
        if (!this.$v.email.$dirty) {
          return errors;
        }
        if (!this.$v.email.required) {
          errors.push(router.app.$t('components.forms.confirm_business.errors.email_required'));
        }
        if (!this.$v.email.email) {
          errors.push(router.app.$t('components.forms.confirm_business.errors.email_valid'));
        }
        return errors;
      },
      passErrors() {
        const errors = [];
        if (!this.$v.password.$dirty) {
          return errors;
        }
        if (!this.$v.password.minLength) {
          errors.push(
            router.app.$t('components.forms.login.errors.password_length').replace('{0}', pass.length)
          );
        }
        if (!this.$v.password.required) {
          errors.push(router.app.$t('components.forms.login.errors.password_required'));
        }
        if (!this.$v.password.hasLowercase) {
          errors.push(router.app.$t('components.forms.login.errors.password_lowercase'));
        }
        if (!this.$v.password.hasUppercase) {
          errors.push(router.app.$t('components.forms.login.errors.password_uppercase'));
        }
        if (!this.$v.password.hasSpecialSymbol) {
          errors.push(router.app.$t('components.forms.login.errors.password_special_symbol'));
        }
        return errors;
      },
      languageErrors() {
        const errors = [];
        if (!this.$v.language.$dirty) {
          return errors;
        }
        if (!this.$v.language.required) {
          errors.push('Language is required');
        }
        return errors;
      },
      timezoneErrors() {
        const errors = [];
        if (!this.$v.timezone.$dirty) {
          return errors;
        }
        if (!this.$v.timezone.required) {
          errors.push('Timezone is required');
        }
        return errors;
      }
    },
    mounted() {
      this.syncUserProfileData();
    },
    methods: {
      submit() {
        this.$v.$touch();

        if (!this.canSubmitRequest() || this.$v.$error || this.$v.pending) {
          return false;
        }
        this.goToNextStep();
      },
      clear() {
        this.$v.$reset();
        this.firstName = '';
        this.lastName = '';
        this.title = '';
        this.email = '';
        this.password = '';
        this.language = '';
        this.timezone = '';
        this.isSubmitted = false;
      },
      goToNextStep() {
        const [targetLanguage] = this.locales.filter(locale => locale.code === this.language);
        const [targetTimezone] = this.timezones.filter(timezone => timezone.id === this.timezone);

        const userProfile = {
          firstName: this.firstName,
          lastName: this.lastName,
          title: this.title,
          email: this.email,
          password: this.password,
          language: targetLanguage.code,
          timezone: targetTimezone.label
        };

        this.onSubmit(userProfile);
      },
      syncUserProfileData() {
        const { firstName, lastName, title, email, password, language, timezone } = this.userProfile;
        this.firstName = firstName;
        this.lastName = lastName;
        this.title = title;
        this.email = email;
        this.password = password;
        this.language = language;
        this.timezone = timezone;
      },
      canSubmitRequest() {
        return this.firstName !== ''
          && this.lastName !== ''
          && this.title !== ''
          && this.email !== ''
          && this.password !== ''
          && this.language !== ''
          && this.timezone !== ''
          && !this.isSubmitted;
      }
    },
  };
</script>

<style lang="stylus" scoped>
  @import '../../../assets/stylus/theme.styl';

  [data-component-group="auth-form"] {
    &[data-component="user-profile"] {
      .first-name-field,
      .language-dropdown {
        margin: 0 $spacing-sm 0 0;
      }

      .language-dropdown,
      .timezone-dropdown {
        width: 50%;
      }

      .form-actions {
        .trigger.register {
          border-radius: 4px;

          &.active {
            color: $colors.shades.white;
            background-color: $colors.primary;
          }

          .v-icon {
            width: 10px;
            margin: 0 0 0 6px;
          }
        }
      }
    }
  }
</style>
